#include "engine\action.h"

// Declaration of all the actions on objects in room
// Implementations are in the actions_*.c files

//////////////////////////////////////////////////////////////////////////
// Room Prison Cell - action_cell.c
//////////////////////////////////////////////////////////////////////////

/* room events */
void action_cell_on_room_draw(void);
void action_cell_on_room_enter(void);

/* actions on objects */

void action_cell_examine(void);

void action_cell_window_examine(void);
void action_cell_window_look_through(void);

void action_cell_torch_examine(void);
void action_cell_torch_get(void);

void action_cell_fire_get(void);

void action_cell_door_open(void);
void action_cell_door_close(void);
void action_cell_door_unlock(void);
void action_cell_door_kick(void);
void action_cell_door_lock(void);
void action_cell_door_enter(void);

//////////////////////////////////////////////////////////////////////////
// Room Prison Hall - action_hall.c
//////////////////////////////////////////////////////////////////////////

/* room events */

void action_hall_on_room_draw(void);
void action_hall_on_room_exit(void);

/* actions on objects */

void action_hall_examine(void);
void action_hall_sniff(void);

void action_hall_prisoner_examine(void);
void action_hall_prisoner_talk_to(void);
void action_hall_prisoner_kill(void);
void action_hall_prisoner_give_item(void);
void action_hall_right_exit_enter(void);

/* other actions */

void action_hall_prisoner_falls_asleep(void);

//////////////////////////////////////////////////////////////////////////
// Room Prison Corridor - action_corridor.c
//////////////////////////////////////////////////////////////////////////

/* room events */

void action_corridor_on_room_draw(void);

/* actions on objects */

void action_corridor_examine(void);

void action_corridor_left_exit_enter(void);

void action_corridor_right_exit_examine(void);
void action_corridor_right_exit_enter(void);

void action_corridor_barrel_examine(void);
void action_corridor_barrel_drop_item(void);
void action_corridor_barrel_get_item(void);

void action_corridor_herbs_examine(void); 
void action_corridor_herbs_get(void);
void action_corridor_herbs_use_on_item(void);

void action_corridor_beer_bottle_examine(void); 
void action_corridor_beer_bottle_use_on_item(void); 
void action_corridor_beer_bottle_drink(void); 

void action_corridor_improved_beer_examine(void); 
void action_corridor_improved_beer_drink(void);
void action_corridor_improved_beer_give(void); 

//////////////////////////////////////////////////////////////////////////
// Room independent actions
//////////////////////////////////////////////////////////////////////////

void action_guard_attacks_player(void);
void action_finish_demo(void);
