// This file contains definitions of game logic for the Prison Corridor
#include "game\all_definitions.h"

void action_corridor_on_room_draw(void)
{
	picture_draw(room_current_picture_get(),16,0);
}

void action_corridor_examine(void)
{
	console_print("This room serves as the living area for the Skorl guards.",true);
	if (object_value_get(OBJECT_CORRIDOR_HERBS)==OBJECT_CORRIDOR_HERBS_ON_SCREEN)
	{
		console_print("There are some herbs growing by the sacks in the corner.",true);
		area_activity_on(OBJECT_CORRIDOR_HERBS);
	}
}

void action_corridor_left_exit_enter(void)
{
	room_current_set(ROOM_HALL);	
}

void action_corridor_right_exit_examine(void)
{
	console_print("This magic portals prevents to pass when infidels are around.",true);
}

void action_corridor_right_exit_enter(void)
{
	if (object_value_get(OBJECT_HALL_PRISONER)!=OBJECT_PRISONER_SLEEPING)
	{
		console_print("The portal is closed.",true);
	}
	else
	{
		action_finish_demo();
	}
}

void action_corridor_barrel_examine(void)
{
	console_print("A big barrel that can be used as a container.",true);
}

void action_corridor_barrel_drop_item(void)
{
	object_id obj;
	if (container_get_number_of_items(CONTAINER_BARREL_IN_PRISON)>=MAX_OBJECTS_INSIDE_CONTAINER)
	{
		console_print("There is no more place in the barrel.",true);
		return;
	}
	obj=container_object_move_with_choose(CONTAINER_INVENTORY,CONTAINER_BARREL_IN_PRISON);
	if (obj!=OBJECT_NONE)
	{
		console_print("You have dropped a ",false);
		console_print(object_name_get(obj),false);
		console_print(".",true);
	}	
}

void action_corridor_barrel_get_item(void)
{
	object_id obj;
	if (container_get_number_of_items(CONTAINER_INVENTORY)>=MAX_OBJECTS_INSIDE_CONTAINER)
	{
		console_print("You have no place in your inventory.",true);
		return;
	}
	obj=container_object_move_with_choose(CONTAINER_BARREL_IN_PRISON,CONTAINER_INVENTORY);
	if (obj!=OBJECT_NONE)
	{
		console_print("You have taken a ",false);
		console_print(object_name_get(obj),false);
		console_print(".",true);
	}	
}

void action_corridor_herbs_examine(void)
{
	console_print("A sleeping herbs.",true);
}

void action_corridor_herbs_get(void)
{
	if (container_insert(CONTAINER_INVENTORY,OBJECT_CORRIDOR_HERBS)!=CONTAINER_ITERATOR_NPOS)
	{
		area_activity_off(OBJECT_CORRIDOR_HERBS);
		object_value_set(OBJECT_CORRIDOR_HERBS,OBJECT_CORRIDOR_HERBS_TAKEN);
		// Change action 'get' in object herbs to action 'use'
		object_action_replace(OBJECT_CORRIDOR_HERBS,action_corridor_herbs_get,action_corridor_herbs_use_on_item,"Use on item");
		console_print("You have taken the herbs.",true);
	}
	else
	{
		console_print("You have no room in your inventory.",true);
	}
}

void action_corridor_herbs_use_on_item(void)
{
	object_id obj=ui_container_choose_item(CONTAINER_INVENTORY);
	if (obj==OBJECT_CORRIDOR_BEER_BOTTLE)
	{
		container_merge(CONTAINER_INVENTORY,
						OBJECT_CORRIDOR_HERBS,
						OBJECT_CORRIDOR_BEER_BOTTLE,
						OBJECT_CREATED_IMPROVED_BEER);
		console_print("You have mixed sleeping herbs with a beer.",true);
	}
}

void action_corridor_beer_bottle_drink(void)
{
	console_print("It would be great, but your good sense stops you.",true);
}

void action_corridor_beer_bottle_use_on_item(void)
{
	object_id obj=ui_container_choose_item(CONTAINER_INVENTORY);
	if (obj==OBJECT_CORRIDOR_HERBS)
	{
		container_merge(CONTAINER_INVENTORY,
			OBJECT_CORRIDOR_HERBS,
			OBJECT_CORRIDOR_BEER_BOTTLE,
			OBJECT_CREATED_IMPROVED_BEER);
		console_print("You have mixed sleeping herbs with a beer.",true);
	}
}

void action_corridor_beer_bottle_examine(void)
{
	console_print("A bottle full of Pilsner Urquel.",true);
}

void action_corridor_improved_beer_examine(void)
{
	console_print("A stein of sleeping beer.",true);
}

void action_corridor_improved_beer_drink(void)
{
	console_print("You don't want to have a great headache later...",true);
}

// If you want to use area on object and object on area, then both must be defined
void action_corridor_improved_beer_give(void)
{
	object_id obj = ui_object_choose(room_current_get());
	if (obj==OBJECT_HALL_PRISONER)
		action_hall_prisoner_falls_asleep();
}

void action_finish_demo(void)
{
	console_print("You have won the game!\nNow try to make your own :)",false);
infinite_loop:
		goto infinite_loop;
}