#include "game\all_definitions.h"

// First define areas, then objects

struct s_object g_objects[OBJECT_LAST_OBJECT]={

	//////////////////////////////////////////////////////////////////////////
	// Room Prison Cell
	//////////////////////////////////////////////////////////////////////////

	// OBJECT_CELL
	{
		// Name, variable
		"Prison cell", 0,
		// Actions on object
		{
			{"Examine",action_cell_examine},
			{TEXT_NONE,ACTION_NONE},
			{TEXT_NONE,ACTION_NONE},
			{TEXT_NONE,ACTION_NONE},
		}
	},
	// OBJECT_CELL_WINDOW,
	{
		// Name, variable
		"Window", 0,
		// Actions on object
		{
			{"Examine",       action_cell_window_examine},
			{"Look through",  action_cell_window_look_through},
			{TEXT_NONE,ACTION_NONE},
			{TEXT_NONE,ACTION_NONE},
		}
	},
	// OBJECT_CELL_TORCH,
	{
		// Name, variable
		"Torch", 0,
		// Actions on object
		{
			{"Examine", action_cell_torch_examine},
			{"Get",    action_cell_torch_get},
			{TEXT_NONE,ACTION_NONE},
			{TEXT_NONE,ACTION_NONE},
		}
	},
	// OBJECT_CELL_FIRE,
	{
		// Name, variable
		"Fire", AREA_INACTIVE, // starts as inactive area
		// Actions on object
		{
			{"Get", action_cell_fire_get},
			{TEXT_NONE,ACTION_NONE},
			{TEXT_NONE,ACTION_NONE},
			{TEXT_NONE,ACTION_NONE},
		}
	},
	// OBJECT_CELL_DOOR,
	{
		// Name, variable
		"Cell door", OBJECT_CELL_DOOR_CLOSED|OBJECT_CELL_DOOR_LOCKED|AREA_ACTIVE, 
		// Actions on object
		{
			{"Open",   action_cell_door_open},
			{"Close",  action_cell_door_close},
			{"Unlock", action_cell_door_unlock},
			{"Kick",   action_cell_door_kick},
			// will be changed to {"Lock",   action_cell_door_lock}, when player enters Room Hall 
		}
	},
	//////////////////////////////////////////////////////////////////////////
	// Room Prison Hall
	//////////////////////////////////////////////////////////////////////////
	// OBJECT_HALL,
	{
		// Name, variable
		"Prison Hall", 0, 
		// Actions on object
		{
			{"Examine", action_hall_examine},
			{"Sniff",   action_hall_sniff},
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// 	OBJECT_HALL_PRISONER
	{
		// Name, variable
		"Prisoner", 0, 
		// Actions on object
		{
			{"Examine",  action_hall_prisoner_examine},
			{"Talk to",  action_hall_prisoner_talk_to},
			{TEXT_NONE,  ACTION_NONE},
			{TEXT_NONE,  ACTION_NONE},
		}
	},
	// 	OBJECT_HALL_RIGHT_EXIT
	{
		// Name, variable
		"Enterance", 0, 
		// Actions on object
		{
			{"Enter",  action_hall_right_exit_enter},
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// 	OBJECT_HALL_CELL_DOOR_REF
	{
		// Name = 0 - reference, variable
		0, OBJECT_CELL_DOOR, 
		// Actions on object
		{
			{TEXT_NONE, ACTION_NONE}, // nothing here. It's just a reference to object defined in other area.
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	//////////////////////////////////////////////////////////////////////////
	// Room Prison Corridor
	//////////////////////////////////////////////////////////////////////////	
	// OBJECT_CORRIDOR
	{
		// Name, variable
		"Prison Corridor", 0, 
		// Actions on object
		{
			{"Examine", action_corridor_examine}, // makes the herbs area active
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// OBJECT_CORRIDOR_LEFT_EXIT
	{
		// Name, variable
		"Hall enterance", 0, 
		// Actions on object
		{
			{"Enter", action_corridor_left_exit_enter}, 
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// OBJECT_CORRIDOR_RIGHT_EXIT
	{
		// Name, variable
		"Magic portal", 0, 
		// Actions on object
		{
			{"Examine", action_corridor_right_exit_examine},
			{"Enter", action_corridor_right_exit_enter}, 
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// OBJECT_CORRIDOR_BARREL_CONTAINER,
	{
		// Name, variable
		"Big Barrel", 0, 
		// Actions on object
		{
			{"Examine",   action_corridor_barrel_examine}, 
			{"Get item",  action_corridor_barrel_get_item},  
			{"Drop item", action_corridor_barrel_drop_item}, 
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// OBJECT_CORRIDOR_HERBS
	{
		// Name, variable
		"Herbs", AREA_INACTIVE,  // this area is inactive now. To find herbs you must examine the main room area
		// Actions on object
		{
			{"Examine",   action_corridor_herbs_examine}, 
			{"Get",       action_corridor_herbs_get}, 
			{TEXT_NONE, ACTION_NONE},
			{TEXT_NONE, ACTION_NONE},
		}
	},

	//////////////////////////////////////////////////////////////////////////
	// End of areas - now other object definition start from objects_def.h
	//////////////////////////////////////////////////////////////////////////

	// OBJECT_CORRIDOR_BEER_BOTTLE
	{
		// Name, variable
		"Beer Bottle", 0,  
			// Actions on object
		{
			{"Examine",  action_corridor_beer_bottle_examine}, 
			{"Use with", action_corridor_beer_bottle_use_on_item}, 
			{"Drink",    action_corridor_beer_bottle_drink},
			{TEXT_NONE, ACTION_NONE},
		}
	},
	// OBJECT_NEW_IMPROVED_BEER
	{
		// Name, variable
		"Improved beer", 0,  
		// Actions on object
		{
			{"Examine", action_corridor_improved_beer_examine}, 
			{"Drink",   action_corridor_improved_beer_drink}, 
			{"Give",    action_corridor_improved_beer_give}, // if you want to make two way actions (area-obj, obj-area) you must define it
			{TEXT_NONE, ACTION_NONE},
		}
	},
};

