#ifndef OBJECTS_H
#define OBJECTS_H

#include "game\areas\areas_def.h"

//////////////////////////////////////////////////////////////////////////
// IDs of objects
//////////////////////////////////////////////////////////////////////////

// First objects are areas (areas_def.h), here we assign IDs for the rest

enum {
	OBJECT_FIRST=AREA_LAST_AREA,
	OBJECT_CORRIDOR_BEER_BOTTLE = OBJECT_FIRST, // first object that is not an area
	OBJECT_CREATED_IMPROVED_BEER, // = beer + herbs 
	OBJECT_LAST_OBJECT // the last object - this sets the size of the table
};

//////////////////////////////////////////////////////////////////////////
// Object properties 
//////////////////////////////////////////////////////////////////////////

enum {
	// The 0x80 bit is for the area, therefore variable values may be up to 0x7F
	OBJECT_PRISONER_QUIET  =0,
	OBJECT_PRISONER_YELLING=1,
	OBJECT_PRISONER_SLEEPING=2,

	// we may use 0x to distinguish flags
	OBJECT_CELL_DOOR_CLOSED=0x1, // as flags
	OBJECT_CELL_DOOR_LOCKED=0x2, // as flags, next flags are 0x4, 0x8, 0x10...

	OBJECT_CORRIDOR_HERBS_ON_SCREEN=0,
	OBJECT_CORRIDOR_HERBS_TAKEN=1,
};

#endif